unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Chart1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Chart1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ClickSeries: TLineSeries;

implementation

{$R *.dfm}

procedure TForm1.Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ClickSeries := TLineSeries(Series);
  Form1.Caption := ClickSeries.Name + ' Clicked!';
  Beep();
end;

procedure TForm1.Chart1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
  begin
    if TChart(Sender).Zoomed then
      TChart(Sender).UndoZoom;
  end;
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  i: integer;
  v: double;
begin
  if assigned(ClickSeries) then
  begin
    v := ClickSeries.YScreenToValue(y);
    for i := 0 to ClickSeries.Count - 1 do
      ClickSeries.YValue[i] := v;
    Chart1.Refresh;
  end;
end;

procedure TForm1.Chart1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ClickSeries := nil;
  Form1.Caption := 'Form1';
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;
begin

  ClickSeries := nil;

  // Series 1 - Unable to Click
  Series1.ClickableLine := true;
  Series1.Clear;
  Series1.AddXY(0, 100);
  Series1.AddXY(100, 100);

  // Series 2 - Able to Click when zoomed out (unable to click when zoomed in);
  Series2.ClickableLine := true;
  Series2.Clear;
  Series2.AddXY(0, 50);
  Series2.AddXY(0, 50); // <-- Additional lines
  Series2.AddXY(100, 50);

end;

end.
